require 'forwardable'

module GandiCli
  class Record
    extend Forwardable
    def_delegators :@record_info, :id, :type, :ttl, :name, :value
    attr_reader :client, :zone_id, :version_id
    def initialize(client, zone_id, version_id, record_info)
      @client = client
      @zone_id = zone_id
      @version_id = version_id
      @record_info = record_info
    end

    def delete
      client.domain.zone.record.delete(zone_id, version_id, :id => id)
    end
  end
end
