module GandiCli
  class Zone
    extend Forwardable
    class << self
      def list(client)
        client.domain.zone.list.map{|zone_info|
          new(client, zone_info)
        }
      end

      def find(client, name)
        zone = client.domain.zone.list.find{|zone_info|
          zone_info.name == name
        }
        new(client, zone)
      end
    end

    def_delegators :@zone_info, :id, :name

    attr_reader :client, :zone_info

    def initialize(client, zone_info)
      @client = client
      @zone_info = zone_info
    end

    def versions
      client.domain.zone.version.list(id).map{|version_info|
        ZoneVersion.new(client, id, version_info.id)
      }
    end

    def version
      ZoneVersion.new(client, id, zone_info.version)
    end

    def find_version(version)
      ZoneVersion.new(client, id, version)
    end
  end
end
