module GandiCli
  class ZoneVersion
    attr_reader :client, :zone_id, :id
    def initialize(client, zone_id, id)
      @client = client
      @zone_id = zone_id
      @id = id.to_i
    end

    def to_s
      "#{zone_id}:#{id}"
    end

    def copy
      new_zone_id = client.domain.zone.version.new(zone_id, id)
      ZoneVersion.new(client, zone_id, new_zone_id)
    end

    def records
      client.domain.zone.record.list(zone_id, id).map do |record_info|
        Record.new(client, zone_id, id, record_info)
      end
    end

    def add_record(type, ttl, name, value)
      client.domain.zone.record.add(zone_id, id,
                                    :type => type,
                                    :ttl => ttl,
                                    :name => name,
                                    :value => value)
    end

    def activate!
      client.domain.zone.version.set(zone_id, id)
    end
  end
end
